//Console mode YModem demonstration program
//Direct PC to PC multi-file transfers from the command line
//Requires HyperString v4.50+, YModem and Crt_EFD unit
program YMDemo;

{$APPTYPE CONSOLE}

uses
  Windows, SysUtils, Crt_EFD, HyperStr, YModem;

{$R *.RES}

var
  I:Integer;
  TX:TYModemTX;
  RX:TYModemRX;
  Reply,FilePath,Dial:AnsiString;
  RXFlag:Boolean = False;
  Port:THandle = INVALID_HANDLE_VALUE;
  IniStr:AnsiString = 'AT &F E0 V1 &C1 &D2 &K0 |';  //modem initialization string

  procedure OurStatusRoutine(Sender:TObject;S:AnsiString); //Status callback
  begin                                                    //req'd by YModem threads
    WriteLn(S);
  end;

  procedure SendRecv; //Do the transfer
  begin
    try
      Port := OpenComm('COM'+IntToStr(I)+': BAUD=57600 PARITY=N DATA=8 STOP=1');
    except
      WriteLn('Bad Port !!!');
      Exit;
    end;
    if ModemThere(Port) then begin
      WriteLn('Modem found, initializing');
      if ModemCommand(Port,IniStr) then begin
        WriteLn('Initialization OK');
        if not RXFlag then begin
          WriteLn('Dialing');
          ModemCommand(Port,Dial+':');
        end;
        WriteLn('Waiting to connect');
        repeat
          Reply := ModemResponse(Port);
          I:=ScanOr(Reply,'ECT|O |USY',1); //look for "CONNECT|NO ???|BUSY"
        until (I>0) or KeyPressed;
        WriteLn(Reply);
        if (I>0) and (Reply[I]='E') then begin //connected ?
          if RXFlag then begin
            RX := TYModemRX.Create(Port,FilePath,OurStatusRoutine);
            I := RX.WaitFor; //fiddle while the modem burns
            RX.Destroy;
          end else begin
            TX := TYModemTX.Create(Port,FilePath,OurStatusRoutine);
            I := TX.WaitFor; //fiddle while the modem burns
            TX.Destroy;
          end;
          if I>0 then WriteLn('Success !!!, Average CPS = ',I);
        end;
      end else WriteLn('Error initializing');
    end else WriteLn('Modem not found!');
    WriteLn('Closing port');
    CloseComm(Port);
  end;

begin
  ClrScr;
  WriteLn('YModem test program!!!');
  if ParamCount<2 then begin
    WriteLn;
    Writeln('Syntax: YMDemo filepath comport ["dialstr"]');
    Writeln;
    WriteLn('        filepath = files to send (comma separated)');
    WriteLn('            ..or.. path  to recv ([@] = current/default)');
    WriteLn('         comport = port number ([1] = COM1:, [2] = COM2:, etc.)');
    WriteLn('         dialstr = Dial string if TX (Example: "ATDT 555 1212")');
    WriteLn('                   Null if RX');
  end else begin
    FilePath := ParamStr(1);
    I := StrToIntDef(ParamStr(2),0);
    if I>0 then begin
      if ParamCount=2 then begin
        RXFlag := True;
        IniStr := IniStr + 'AT S0=1|'; //add auto answer if receiving
      end else Dial:=ParamStr(3);
      SendRecv;    //do the transfer
    end else WriteLn('Invalid Port');
    Write('Press any key to continue . . .');
  end;
  ReadKey;
end.

